//calculation of permutation and combination using function in C
//which is what OpenGL is based on.

int fact(int n){
	int fac = 1;
	int i;

	for(i = n; i > 0; i--){
		fac = fac*i;
	}

	return fac;
}
 
 
int nPr(int n,int r){
	int perm;
	perm = fact(n)/(fact(n-r));

	return perm;
}
 
 
int nCr(int n,int r){
	int comb;
	comb = fact(n)/(fact(n-r)*fact(r));

	return comb; 
}

//proceeds with calculating the N-order Bezier Curve

int N = 9;

float bezierCurve(float n, int k, float p) {
	return nCr(N, k) * pow(1.0 - n, N - k) * pow(n, k) * p;
}